package com.gxzc.zen.web.sys.controller

import com.gxzc.zen.common.base.BaseController
import com.gxzc.zen.common.dto.ZenMultipartFileDTO
import com.gxzc.zen.common.util.UploadUtil
import io.swagger.annotations.ApiOperation
import org.slf4j.LoggerFactory
import org.springframework.http.HttpStatus
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

/**
 * 上传文件 控制器
 * @author NorthLan
 * @date 2018/5/19
 * @url https://noahlan.com
 */
@RestController
@RequestMapping("/upload")
class UploadController : BaseController() {
    companion object {
        private val logger = LoggerFactory.getLogger(UploadController::class.java)
    }

    @ApiOperation("检查已上传分片")
    @GetMapping
    fun checkChunk(fileDTO: ZenMultipartFileDTO): ResponseEntity<*> {
        // 检查文件是否存在
        return if (UploadUtil.uploadGet(fileDTO)) {
            ResponseEntity.ok(null)
        } else {
            ResponseEntity.status(204).body(null)
        }
    }

    @ApiOperation("分片上传", notes = "保留源文件夹结构/文件名")
    @PostMapping
    fun upload(fileDTO: ZenMultipartFileDTO): ResponseEntity<*> {
        if (fileDTO.file == null) {
            return ResponseEntity.status(HttpStatus.NOT_ACCEPTABLE.value()).body(null)
        }
        return if (UploadUtil.upload(fileDTO)) {
            ResponseEntity.ok(null)
        } else {
            ResponseEntity.status(HttpStatus.NOT_ACCEPTABLE.value()).body(null)
        }
    }

    @ApiOperation("分片上传(批量)", notes = "不保留源文件夹结构/文件名")
    fun PostMapping() {

    }
}